// Genesaver: copyright 2003 Sam Stafford.

struct Pixel;
class World;

#include "thing.h"
#include "brain.h"
#include "dna.h"

class Animal :
	public Thing
{
public:
	Animal( DNA* dna );
	~Animal(void);

	void Render();
	void RenderFitness();

	void CheckFitness( World* w );
	void Eat( Pixel** p, int w, int h );
	void LookNear( Pixel** p, int w, int h );
	void LookFar( int rx, int ry, int gx, int gy, int bx, int by );
	void Step( World* w );

	float r, g, b; //animal color

	float fitness; //current fitness level
	float fitness_relative; //relative fitness on 0 to 1 scale.

	float muscles[4]; // x-accel, y-accel, v-accel, turn

	// Velocity vector in linear and polar coords.
	float velocity_x;
	float velocity_y;
	float speed;
	float angle; // radians

	bool tagged; //is World->tagged

	float meter_hue; //used for chasecam render

	Animal *hi, *lo;

	Brain brain;
	DNA* dna;
};
